// Auto-generated. Do not edit!

// (in-package thormang3_walking_module_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let StepPositionData = require('./StepPositionData.js');
let StepTimeData = require('./StepTimeData.js');

//-----------------------------------------------------------

class StepData {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.position_data = null;
      this.time_data = null;
    }
    else {
      if (initObj.hasOwnProperty('position_data')) {
        this.position_data = initObj.position_data
      }
      else {
        this.position_data = new StepPositionData();
      }
      if (initObj.hasOwnProperty('time_data')) {
        this.time_data = initObj.time_data
      }
      else {
        this.time_data = new StepTimeData();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type StepData
    // Serialize message field [position_data]
    bufferOffset = StepPositionData.serialize(obj.position_data, buffer, bufferOffset);
    // Serialize message field [time_data]
    bufferOffset = StepTimeData.serialize(obj.time_data, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type StepData
    let len;
    let data = new StepData(null);
    // Deserialize message field [position_data]
    data.position_data = StepPositionData.deserialize(buffer, bufferOffset);
    // Deserialize message field [time_data]
    data.time_data = StepTimeData.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 144;
  }

  static datatype() {
    // Returns string type for a message object
    return 'thormang3_walking_module_msgs/StepData';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '5c123ac289a192451dda1d18cbffa1a0';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    ## the step data for thormang3, composed of position and time data
    
    StepPositionData position_data
    StepTimeData     time_data
    ================================================================================
    MSG: thormang3_walking_module_msgs/StepPositionData
    #### Step Position Data
    
    ## MovingFootFlag
    int16 moving_foot
    
    int16 LEFT_FOOT_SWING  = 1 # Left foot constant
    int16 RIGHT_FOOT_SWING = 2 # Right foot constant
    int16 STANDING         = 3 # No foot constant
    
    ## Unit [meter, rad]
    float32     foot_z_swap
    float32     body_z_swap
    float32     x_zmp_shift
    float32     y_zmp_shift
    float32     torso_yaw_angle_rad
    PoseXYZRPY  left_foot_pose
    PoseXYZRPY  right_foot_pose
    PoseZRPY    body_pose
    ================================================================================
    MSG: thormang3_walking_module_msgs/PoseXYZRPY
    float32 x
    float32 y
    float32 z
    float32 roll
    float32 pitch
    float32 yaw
    ================================================================================
    MSG: thormang3_walking_module_msgs/PoseZRPY
    float32 z
    float32 roll
    float32 pitch
    float32 yaw
    ================================================================================
    MSG: thormang3_walking_module_msgs/StepTimeData
    #### StepTimeData
    
    ## WalkingStateFlag
    int16   walking_state
    
    int16 IN_WALKING_STARTING = 0 #WalkingStarting
    int16 IN_WALKING          = 1 #Walking
    int16 IN_WALKING_ENDING   = 2 #WalkingEnding
    
    ## Unit [sec]
    float32 abs_step_time #global time
    
    # dsp_ratio >= 0.0 dsp_ratio < 1.0, recommend value is 0.2 
    float32 dsp_ratio
    
    # 0.0 <= start_time_delay_ratio    < 1.0
    # 0.0 <= finish_time_advance_ratio < 1.0
    # 0.0 <= start_time_delay_ratio +  finish_time_advance_ratio < 1.0
    # default value is 0.0
    float32 start_time_delay_ratio_x
    float32 start_time_delay_ratio_y
    float32 start_time_delay_ratio_z
    float32 start_time_delay_ratio_roll
    float32 start_time_delay_ratio_pitch
    float32 start_time_delay_ratio_yaw
    float32 finish_time_advance_ratio_x
    float32 finish_time_advance_ratio_y
    float32 finish_time_advance_ratio_z
    float32 finish_time_advance_ratio_roll
    float32 finish_time_advance_ratio_pitch
    float32 finish_time_advance_ratio_yaw
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new StepData(null);
    if (msg.position_data !== undefined) {
      resolved.position_data = StepPositionData.Resolve(msg.position_data)
    }
    else {
      resolved.position_data = new StepPositionData()
    }

    if (msg.time_data !== undefined) {
      resolved.time_data = StepTimeData.Resolve(msg.time_data)
    }
    else {
      resolved.time_data = new StepTimeData()
    }

    return resolved;
    }
};

module.exports = StepData;
